exercises/boot_from_volume.sh
440be4b6
 #!/usr/bin/env bash
 
 # **boot_from_volume.sh**
 
 # This script demonstrates how to boot from a volume.  It does the following:
fc65cfed
 #  *  Create a bootable volume
 #  *  Boot a volume-backed instance
440be4b6
 
27e32699
 echo "*********************************************************************"
440be4b6
 echo "Begin DevStack Exercise: $0"
27e32699
 echo "*********************************************************************"
440be4b6
 
 # This script exits on an error so that errors don't compound and you see
 # only the first error that occured.
 set -o errexit
 
 # Print the commands being run so that we can see the command that triggers
 # an error.  It is also useful for following allowing as the install occurs.
 set -o xtrace
 
 
 # Settings
 # ========
 
 # Keep track of the current directory
 EXERCISE_DIR=$(cd $(dirname "$0") && pwd)
 TOP_DIR=$(cd $EXERCISE_DIR/..; pwd)
 
 # Import common functions
 source $TOP_DIR/functions
 
 # Import configuration
 source $TOP_DIR/openrc
 
5db5bfa2
 # Import quantum functions if needed
 if is_service_enabled quantum; then
     source $TOP_DIR/lib/quantum
 fi
 
440be4b6
 # Import exercise configuration
 source $TOP_DIR/exerciserc
 
6fd28117
 # If cinder is not enabled we exit with exitcode 55 so that
fc65cfed
 # the exercise is skipped
6fd28117
 is_service_enabled cinder || exit 55
fc65cfed
 
da85cdad
 # Instance type to create
 DEFAULT_INSTANCE_TYPE=${DEFAULT_INSTANCE_TYPE:-m1.tiny}
 
440be4b6
 # Boot this image, use first AMI image if unset
 DEFAULT_IMAGE_NAME=${DEFAULT_IMAGE_NAME:-ami}
 
da85cdad
 # Security group name
 SECGROUP=${SECGROUP:-boot_secgroup}
440be4b6
 
da85cdad
 # Instance and volume names
 VM_NAME=${VM_NAME:-ex-bfv-inst}
 VOL_NAME=${VOL_NAME:-ex-vol-bfv}
440be4b6
 
27e32699
 
da85cdad
 # Launching a server
 # ==================
 
 # List servers for tenant:
 nova list
96288ba9
 
da85cdad
 # Images
 # ------
96288ba9
 
da85cdad
 # List the images available
 glance image-list
27e32699
 
440be4b6
 # Grab the id of the image to launch
da85cdad
 IMAGE=$(glance image-list | egrep " $DEFAULT_IMAGE_NAME " | get_field 1)
07115eb5
 die_if_not_set $LINENO IMAGE "Failure getting image $DEFAULT_IMAGE_NAME"
da85cdad
 
 # Security Groups
 # ---------------
 
 # List security groups
 nova secgroup-list
 
 # Create a secgroup
 if ! nova secgroup-list | grep -q $SECGROUP; then
     nova secgroup-create $SECGROUP "$SECGROUP description"
     if ! timeout $ASSOCIATE_TIMEOUT sh -c "while ! nova secgroup-list | grep -q $SECGROUP; do sleep 1; done"; then
         echo "Security group not created"
         exit 1
     fi
 fi
440be4b6
 
da85cdad
 # Configure Security Group Rules
 if ! nova secgroup-list-rules $SECGROUP | grep -q icmp; then
     nova secgroup-add-rule $SECGROUP icmp -1 -1 0.0.0.0/0
 fi
 if ! nova secgroup-list-rules $SECGROUP | grep -q " tcp .* 22 "; then
     nova secgroup-add-rule $SECGROUP tcp 22 22 0.0.0.0/0
 fi
440be4b6
 
da85cdad
 # List secgroup rules
 nova secgroup-list-rules $SECGROUP
440be4b6
 
da85cdad
 # Set up instance
 # ---------------
440be4b6
 
da85cdad
 # List flavors
 nova flavor-list
440be4b6
 
da85cdad
 # Select a flavor
 INSTANCE_TYPE=$(nova flavor-list | grep $DEFAULT_INSTANCE_TYPE | get_field 1)
440be4b6
 if [[ -z "$INSTANCE_TYPE" ]]; then
     # grab the first flavor in the list to launch if default doesn't exist
da85cdad
    INSTANCE_TYPE=$(nova flavor-list | head -n 4 | tail -n 1 | get_field 1)
 fi
 
 # Clean-up from previous runs
 nova delete $VM_NAME || true
 if ! timeout $ACTIVE_TIMEOUT sh -c "while nova show $VM_NAME; do sleep 1; done"; then
     echo "server didn't terminate!"
     exit 1
440be4b6
 fi
 
 # Setup Keypair
 KEY_NAME=test_key
 KEY_FILE=key.pem
 nova keypair-delete $KEY_NAME || true
 nova keypair-add $KEY_NAME > $KEY_FILE
 chmod 600 $KEY_FILE
 
da85cdad
 # Set up volume
 # -------------
440be4b6
 
da85cdad
 # Delete any old volume
 cinder delete $VOL_NAME || true
 if ! timeout $ACTIVE_TIMEOUT sh -c "while cinder list | grep $VOL_NAME; do sleep 1; done"; then
     echo "Volume $VOL_NAME not deleted"
440be4b6
     exit 1
 fi
 
fc65cfed
 # Create the bootable volume
da85cdad
 start_time=$(date +%s)
 cinder create --image-id $IMAGE --display_name=$VOL_NAME --display_description "test bootable volume: $VOL_NAME" $DEFAULT_VOLUME_SIZE || \
07115eb5
     die $LINENO "Failure creating volume $VOL_NAME"
161e2807
 if ! timeout $ACTIVE_TIMEOUT sh -c "while ! cinder list | grep $VOL_NAME | grep available; do sleep 1; done"; then
440be4b6
     echo "Volume $VOL_NAME not created"
     exit 1
 fi
da85cdad
 end_time=$(date +%s)
 echo "Completed cinder create in $((end_time - start_time)) seconds"
 
 # Get volume ID
 VOL_ID=$(cinder list | grep $VOL_NAME  | get_field 1)
07115eb5
 die_if_not_set $LINENO VOL_ID "Failure retrieving volume ID for $VOL_NAME"
440be4b6
 
da85cdad
 # Boot instance
 # -------------
440be4b6
 
da85cdad
 # Boot using the --block_device_mapping param. The format of mapping is:
440be4b6
 # <dev_name>=<id>:<type>:<size(GB)>:<delete_on_terminate>
 # Leaving the middle two fields blank appears to do-the-right-thing
da85cdad
 VM_UUID=$(nova boot --flavor $INSTANCE_TYPE --image $IMAGE --block-device-mapping vda=$VOL_ID --security_groups=$SECGROUP --key_name $KEY_NAME $VM_NAME | grep ' id ' | get_field 2)
07115eb5
 die_if_not_set $LINENO VM_UUID "Failure launching $VM_NAME"
440be4b6
 
 # Check that the status is active within ACTIVE_TIMEOUT seconds
da85cdad
 if ! timeout $ACTIVE_TIMEOUT sh -c "while ! nova show $VM_UUID | grep status | grep -q ACTIVE; do sleep 1; done"; then
440be4b6
     echo "server didn't become active!"
     exit 1
 fi
 
da85cdad
 # Get the instance IP
 IP=$(nova show $VM_UUID | grep "$PRIVATE_NETWORK_NAME" | get_field 2)
07115eb5
 die_if_not_set $LINENO IP "Failure retrieving IP address"
440be4b6
 
da85cdad
 # Private IPs can be pinged in single node deployments
 ping_check "$PRIVATE_NETWORK_NAME" $IP $BOOT_TIMEOUT
fc65cfed
 
da85cdad
 # Clean up
 # --------
440be4b6
 
 # Delete volume backed instance
07115eb5
 nova delete $VM_UUID || die $LINENO "Failure deleting instance $VM_NAME"
da85cdad
 if ! timeout $TERMINATE_TIMEOUT sh -c "while nova list | grep -q $VM_UUID; do sleep 1; done"; then
     echo "Server $VM_NAME not deleted"
     exit 1
 fi
440be4b6
 
da85cdad
 # Wait for volume to be released
161e2807
 if ! timeout $ACTIVE_TIMEOUT sh -c "while ! cinder list | grep $VOL_NAME | grep available; do sleep 1; done"; then
da85cdad
     echo "Volume $VOL_NAME not released"
440be4b6
     exit 1
 fi
 
da85cdad
 # Delete volume
 start_time=$(date +%s)
07115eb5
 cinder delete $VOL_ID || die $LINENO "Failure deleting volume $VOLUME_NAME"
da85cdad
 if ! timeout $ACTIVE_TIMEOUT sh -c "while cinder list | grep $VOL_NAME; do sleep 1; done"; then
     echo "Volume $VOL_NAME not deleted"
     exit 1
 fi
 end_time=$(date +%s)
 echo "Completed cinder delete in $((end_time - start_time)) seconds"
440be4b6
 
da85cdad
 # Delete secgroup
07115eb5
 nova secgroup-delete $SECGROUP || die $LINENO "Failure deleting security group $SECGROUP"
440be4b6
 
 set +o xtrace
27e32699
 echo "*********************************************************************"
 echo "SUCCESS: End DevStack Exercise: $0"
 echo "*********************************************************************"